/*****************************************************************************
 * UC1_Direct_Replacement_Core1.c
 *****************************************************************************/

#include <sys/platform.h>
#include <sys/adi_core.h>
#include "adi_initialize.h"
#include "UC1_Direct_Replacement_Core1.h"

/** 
 * If you want to use command program arguments, then place them in the following string. 
 */
char __argv_string[] = "";

float AppInput[BLOCK_SIZE] =
{
#include "input.dat"
};

float ExpectedOutput[BLOCK_SIZE] =
{
#include "output.dat"
};

float EIIR1[BLOCK_SIZE] =
{
//#include "EIIR1.dat"
};

float EIIR2[BLOCK_SIZE] =
{
//#include "EIIR2.dat"
};

float EIIR3[BLOCK_SIZE] =
{
//#include "EIIR3.dat"
};

float EIIR4[BLOCK_SIZE] =
{
//#include "EIIR4.dat"
};

float EIIR5[BLOCK_SIZE] =
{
//#include "EIIR5.dat"
};

/* Write pointer for circular buffer access for FIR accelerator processing */
volatile unsigned int wp = WP_START;
int i = 0;
int main(int argc, char *argv[])
{
	/**
	 * Initialize managed drivers and/or services that have been added to 
	 * the project.
	 * @return zero on success 
	 */
	adi_initComponents();
	
	START_CYCLE_COUNT

	Init_FIR_IIR();
	/* Write Data to only 1st channel. This is to test that the signal chain is correct and to verify is as expcted */
#if defined(USE_CORE)

	for(i=0; i<BLOCK_SIZE; i++)
	{
		Input[0][i] = AppInput[i];
	}

#elif defined(USE_ACC)
	for(i=0; i<BLOCK_SIZE; i++)
	{
		Input[0][wp+i] = AppInput[i];
	}
	wp+=BLOCK_SIZE;
	wp=wp%(CIRCULAR_BUFFER_LENGTH);
#endif

	//TAKE_CYCLE_SNAPSHOT
	Process_FIR_IIR();
	//TAKE_CYCLE_SNAPSHOT

	while(1);

	return 0;
}

