/*****************************************************************************
 * UC1_Pipelined_Core1.c
 *****************************************************************************/

#include <sys/platform.h>
#include <sys/adi_core.h>
#include "adi_initialize.h"
#include "UC1_Pipelined_Core1.h"

/** 
 * If you want to use command program arguments, then place them in the following string. 
 */
char __argv_string[] = "";

float AppInput[BLOCK_SIZE] =
{
#include "input.dat"
};

float ExpectedOutput[BLOCK_SIZE] =
{
#include "output.dat"
};

float EIIR1[BLOCK_SIZE] =
{
//#include "EIIR1.dat"
};

float EIIR2[BLOCK_SIZE] =
{
//#include "EIIR2.dat"
};

float EIIR3[BLOCK_SIZE] =
{
//#include "EIIR3.dat"
};

float EIIR4[BLOCK_SIZE] =
{
//#include "EIIR4.dat"
};

float EIIR5[BLOCK_SIZE] =
{
//#include "EIIR5.dat"
};

/* Write pointer for circular buffer access for FIR accelerator processing */
volatile unsigned int wp = WP_START;
int i = 0;

extern volatile uint32_t IIRTaskDoneCount;

int main(int argc, char *argv[])
{
	/**
	 * Initialize managed drivers and/or services that have been added to 
	 * the project.
	 * @return zero on success 
	 */
	adi_initComponents();
	
	Init_FIR_IIR();

	START_CYCLE_COUNT;

	for(i=0; i<BLOCK_SIZE; i++)
	{
		/* Write the data to 10th Channel  */
		Input[9][wp+i] = AppInput[i];

	}
	wp+=BLOCK_SIZE;
	wp=wp%(CIRCULAR_BUFFER_LENGTH);

	//TAKE_CYCLE_SNAPSHOT
	Process_FIR_IIR();
	//TAKE_CYCLE_SNAPSHOT

	for(i=0; i<BLOCK_SIZE; i++)
	{
		/* Write the data to 10th Channel Channel */
		Input[9][wp+i] = AppInput[i];

	}
	wp+=BLOCK_SIZE;
	wp=wp%(CIRCULAR_BUFFER_LENGTH);

	while(IIRTaskDoneCount < NCH);

	Process_FIR_IIR();

	while(IIRTaskDoneCount < NCH);

while(1);
}

