/*****************************************************************************
 * UC1_Split_Task.c
 *****************************************************************************/

#include <sys/platform.h>
#include "adi_initialize.h"
#include "UC1_Split_Task.h"

/** 
 * If you want to use command program arguments, then place them in the following string. 
 */
char __argv_string[] = "";

float AppInput[BLOCK_SIZE] =
{
#include "input.dat"
};

float ExpectedOutput[BLOCK_SIZE] =
{
#include "output.dat"
};

float EIIR1[BLOCK_SIZE] =
{
//#include "EIIR1.dat"
};

float EIIR2[BLOCK_SIZE] =
{
//#include "EIIR2.dat"
};

float EIIR3[BLOCK_SIZE] =
{
//#include "EIIR3.dat"
};

float EIIR4[BLOCK_SIZE] =
{
//#include "EIIR4.dat"
};

float EIIR5[BLOCK_SIZE] =
{
//#include "EIIR5.dat"
};

/* Write pointer for circular buffer access for FIR accelerator processing */
volatile unsigned int wp = WP_START;
int i = 0;

int main(int argc, char *argv[])
{
	/**
	 * Initialize managed drivers and/or services that have been added to 
	 * the project.
	 * @return zero on success 
	 */
	adi_initComponents();

	for(i=0; i<BLOCK_SIZE; i++)
	{
		/* Write the data to 2nd Channel and 9th Channel */
		Input[1][wp+i] = AppInput[i];

		Input[8][i] = AppInput[i];

	}
	wp+=BLOCK_SIZE;
	wp=wp%(CIRCULAR_BUFFER_LENGTH);

	Init_FIR_IIR();

	START_CYCLE_COUNT

	Process_FIR_IIR();

	return 0;
}

